// **********************************************************************
// PUCRS/FACIN
// Programa leitura de arquivo texto
//
// Marcio Sarroglia Pinho
//
// pinho@pucrs.br
// **********************************************************************
#include <stdio.h>
#include <stdlib.h>

typedef int BOOL;

#define FALSE 0
#define TRUE 1


// **********************************************************************
unsigned char *CompactaVetor(unsigned char *VetorDeEntrada, int QtdDeDados, int* QtdSaida)
{
    unsigned char *VetorTemp;
    // inicialmente, pode alocar um vetor igual ao da entrada
    VetorTemp = (unsigned char*) malloc (QtdDeDados);

    // No final redimensiona o vetor.
    unsigned char *VetorFinal;

    *QtdSaida = QtdDeDados; // isto devera ser alterado
    VetorFinal = VetorTemp; // isto devera ser alterado

    // e retorna
    return VetorFinal;
}
// **********************************************************************
FILE *AbreArquivoTXT(const char *nome)
{
    FILE *arq;
    arq = fopen (nome,"rt");
    if (arq == NULL)
    {
        printf("Problemas na abertura do arquivo %s...\n", nome);
        return NULL;
    }
    printf("Arquivo %s aberto!\n", nome);
    return arq;
}

// **********************************************************************
void LeTamanhoTXT(FILE *arq, int *largura, int *altura)
{
    //printf("lendo largura e altura...");
    fscanf(arq,"%d", largura);
    fscanf(arq,"%d", altura);
    printf("Largura: %d  -  Altura %d\n",*largura, *altura );

}

// **********************************************************************
void LeDadosTXT(FILE *arq, unsigned char *V, int qtd)
{
    int i, dado;
    for (i=0; i< qtd; i++)
    {
        fscanf(arq, "%d", &dado);
        V[i] = (unsigned char) dado; // coloca o dado no vetor, convertendo para
                            // o caracter de codigo ASCII "dado"
    }

    // DEBUG: exibe vetor na tela
    for(int i=0; i<qtd; i++) {
        if(i%16 == 0)
            printf("\n%4d ", i);
        printf("%02X ",V[i]);
    }
    printf("\n");

}
// **********************************************************************
int main()
{
    FILE *Arquivo;
    char nomeArquivo[] = "1.txt";
    int largura, altura;
    char * VetorDeEntrada;

    Arquivo = AbreArquivoTXT(nomeArquivo);
    if (!Arquivo)
        return 1;
    LeTamanhoTXT(Arquivo, &largura, &altura);

    // Aloca um vetor com o tamanho necessario
    int QtdDeDados = largura * altura;
    VetorDeEntrada = (char*) malloc (sizeof (char) * QtdDeDados);
    if (VetorDeEntrada == NULL)
    {
        printf("Faltou memoria!");
        return 2;
    }
    LeDadosTXT(Arquivo, VetorDeEntrada, QtdDeDados);
    // Neste ponto do codigo, o VetorDeEntrada tem os dados lidos do arquivo
    char *VetorCompactado;
    int QtdDeSaida;
    VetorCompactado = CompactaVetor(VetorDeEntrada, QtdDeDados, &QtdDeSaida);

    printf("Total de elementos na saida: %d\n", QtdDeSaida);
    printf("FIM.");
    free(VetorDeEntrada);
    free(VetorCompactado);
    return 0;

}
